> This documentation belongs to Invofox, an AI-powered document processing
> platform. The API extracts structured data (fields) from unstructured
> documents (invoices, contracts, forms, bank statements, and more).
> Key concepts: Account, Environment, Document Type, Field, File, Import,
> and Document. When answering, prefer the exact terminology defined in the
> Glossary and cite the relevant API Reference endpoint when applicable.

# Create a new provider.

POST https://api.invofox.com/companies/{id}/providers
Content-Type: application/json

Create a new provider for specified company.

Reference: https://developers.invofox.com/api-reference/main-reference/collections/providers/create-a-new-provider

## Authentication

- `x-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `id` (string, required) — id of the company to add a provider to

### Body (application/json)

This endpoint expects an object.

- `countryCode` (string, required) — country code in two-digits format (ISO 3166-1 alpha-2)
- `taxId` (string, required) — Tax id number
- `name` (string, required) — Business name of enterprise

## Response

### 201

Provider successfully registered for specified company

- `result` (CompanyEnterprise, optional)

## Errors

### 400 Bad Request Error

Request error of one of many supported types

- `CreateANewProviderRequestBadRequestError`

### 500 Internal Server Error

Unkown server error

- `code` (string, optional)

## Types

### CompanyEnterprise

- `_id` (string, optional)
- `account` (string, optional)
- `environment` (string, optional)
- `company` (string, optional)
- `name` (string, optional)
- `countryCode` (string, optional)
- `taxId` (string, optional) — Tax id number
- `type` (enum, optional)
  - Allowed values: `client`, `provider`
- `state` (enum, optional)
  - Allowed values: `pending`, `validated`, `discarded`

### ErrMissingParams

Missing some or all parameters

- `code` (string, optional)
- `additionalInfo` (ErrMissingParamsAdditionalInfo, optional)

### ErrRelationAlreadyRegistered

A provider/client with the same CIF has already been registered for this company

- `code` (string, optional)
- `additionalInfo` (ErrRelationAlreadyRegisteredAdditionalInfo, optional)

### ErrMissingParamsAdditionalInfo

- `param` (string, optional) — Name of missing parameter, if there is only one
- `params` (list of string, optional) — Names of missing parameters, if there are several

### ErrRelationAlreadyRegisteredAdditionalInfo

- `type` (enum, optional)
  - Allowed values: `provider`, `client`

## Examples

**Request**

```json
{
  "countryCode": "DE",
  "taxId": "DE123456789",
  "name": "Tech Solutions GmbH"
}
```

**Response**

```json
{
  "result": {
    "_id": "5f8d0d55b54764421b7156c1",
    "account": "acc_987654321",
    "environment": "production",
    "company": "comp_123456789",
    "name": "Tech Solutions GmbH",
    "countryCode": "DE",
    "taxId": "DE123456789",
    "type": "provider",
    "state": "pending"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.invofox.com/companies/id/providers"

payload = {
    "countryCode": "DE",
    "taxId": "DE123456789",
    "name": "Tech Solutions GmbH"
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.invofox.com/companies/id/providers';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"countryCode":"DE","taxId":"DE123456789","name":"Tech Solutions GmbH"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.invofox.com/companies/id/providers"

	payload := strings.NewReader("{\n  \"countryCode\": \"DE\",\n  \"taxId\": \"DE123456789\",\n  \"name\": \"Tech Solutions GmbH\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.invofox.com/companies/id/providers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"countryCode\": \"DE\",\n  \"taxId\": \"DE123456789\",\n  \"name\": \"Tech Solutions GmbH\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.invofox.com/companies/id/providers")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"countryCode\": \"DE\",\n  \"taxId\": \"DE123456789\",\n  \"name\": \"Tech Solutions GmbH\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.invofox.com/companies/id/providers', [
  'body' => '{
  "countryCode": "DE",
  "taxId": "DE123456789",
  "name": "Tech Solutions GmbH"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.invofox.com/companies/id/providers");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"countryCode\": \"DE\",\n  \"taxId\": \"DE123456789\",\n  \"name\": \"Tech Solutions GmbH\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "countryCode": "DE",
  "taxId": "DE123456789",
  "name": "Tech Solutions GmbH"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.invofox.com/companies/id/providers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```